﻿using System;
using System.Threading;
using System.Threading.Tasks;

class Program
{
    static async Task Main(string[] args)
    {
        Console.WriteLine(DateTime.Now);

        Task<int> task1 = AddAsync(3000);
        Task<int> task2 = AddAsync(4000);

        await Task.WhenAll<int>(task1, task2);

        Console.WriteLine(DateTime.Now);
    }

    private static Task<int> AddAsync(int sleepTime)
    {
        /*
        return Task.Run(() =>
        {
            Thread.Sleep(sleepTime);
            return 0;
        });
        */

        return Task.FromResult<int>(Sleep(sleepTime));
    }

    private static int Sleep(int sleepTime)
    {
        Thread.Sleep(sleepTime);
        return 0;
    }

    private static Task SleepAsync(int sleepTime)
    {
        return Task.Delay(sleepTime);

        /*
        TaskCompletionSource<object> source = new TaskCompletionSource<object>();

        Thread.Sleep(sleepTime);

        return source.Task;
        */
    }

}
